
// IsapiSim.h
// 05-02-1999 Sven B. Schreiber
// sbs@orgon.com

////////////////////////////////////////////////////////////////////
#ifdef _ISAPISIM_DLL_
////////////////////////////////////////////////////////////////////

// =================================================================
// PROGRAM IDENTIFICATION
// =================================================================

#define MAIN_BUILD              2
#define MAIN_VERSION_HIGH       1
#define MAIN_VERSION_LOW        1

// -----------------------------------------------------------------

#define MAIN_DAY                02
#define MAIN_MONTH              05
#define MAIN_YEAR               1999

// -----------------------------------------------------------------

#define MAIN_PREFIX             SBS
#define MAIN_MODULE             IsapiSim
#define MAIN_NAME               ISAPI Extension Simulator
#define MAIN_COMPANY            Sven B. Schreiber
#define MAIN_AUTHOR             Sven B. Schreiber
#define MAIN_EMAIL              sbs@orgon.com
#define MAIN_DLL

////////////////////////////////////////////////////////////////////
#endif // #ifdef _ISAPISIM_DLL_
////////////////////////////////////////////////////////////////////

// =================================================================
// HEADER FILES
// =================================================================

#include <proginfo.h>

////////////////////////////////////////////////////////////////////
#ifndef _RC_PASS_
////////////////////////////////////////////////////////////////////

// =================================================================
// MORE HEADER FILES
// =================================================================

#include <httpext.h>

// =================================================================
// STATUS CODES
// =================================================================

#define ISAPI_STATUS_UNDEFINED          0
#define ISAPI_STATUS_OK                 1
#define ISAPI_STATUS_ERROR_PARAMETER    2
#define ISAPI_STATUS_ERROR_LOAD         3
#define ISAPI_STATUS_ERROR_START        4
#define ISAPI_STATUS_ERROR_RUN          5
#define ISAPI_STATUS_ERROR_DISPLAY      6

#define ISAPI_VERSION_MAJOR             2
#define ISAPI_VERSION_MINOR             0

#define ISAPI_DATA                      0x00010000

#define HTTP_STATUS_OK                  200

#define MAX_QUERY                       1024

// =================================================================
// POINTER TYPES
// =================================================================

typedef EXTENSION_CONTROL_BLOCK *PEXTENSION_CONTROL_BLOCK;
typedef HSE_VERSION_INFO        *PHSE_VERSION_INFO;

// =================================================================
// STRUCTURES
// =================================================================

typedef struct _ISAPI_TEST
    {
    HMODULE hModule;
    PROC    GetExtensionVersion;
    PROC    HttpExtensionProc;
    PROC    TerminateExtension;
    PVOID   pData;
    DWORD   dData;
    DWORD   dSize;
    }
    ISAPI_TEST, *PISAPI_TEST, **PPISAPI_TEST;

#define ISAPI_TEST_ sizeof (ISAPI_TEST)

// -----------------------------------------------------------------

typedef struct _ISAPI_QUERY
    {
    BOOL fPost;
    BYTE abHome       [MAX_PATH];
    BYTE abFolder     [MAX_PATH];
    BYTE abFile       [MAX_PATH];
    BYTE abInfo       [MAX_PATH];
    BYTE abTranslated [MAX_PATH];
    BYTE abQuery      [MAX_QUERY];
    }
    ISAPI_QUERY, *PISAPI_QUERY, **PPISAPI_QUERY;

#define ISAPI_QUERY_ sizeof (ISAPI_QUERY)

// -----------------------------------------------------------------

typedef struct _ISAPI_VALUE
    {
    PBYTE pbValue;
    PBYTE pbData;
    }
    ISAPI_VALUE, *PISAPI_VALUE, **PPISAPI_VALUE;

#define ISAPI_VALUE_ sizeof (ISAPI_VALUE)

// =================================================================
// API PROTOTYPES
// =================================================================

INT WINAPI IsapiBox (HWND  hWnd,
                     UINT  uiType,
                     PBYTE pbCaption,
                     PBYTE pbFormat,
                     ...);

BOOL WINAPI IsapiCompare (BYTE bData,
                          BYTE bPattern,
                          BOOL fCase);

BOOL WINAPI IsapiMatch (PBYTE pbData,
                        DWORD dData,
                        PBYTE pbPattern,
                        DWORD dPattern,
                        BOOL  fCase);

BOOL WINAPI IsapiCopy (PBYTE pbData,
                       DWORD dData,
                       PBYTE pbBuffer,
                       DWORD dBuffer);

PVOID WINAPI IsapiMemoryCreate (DWORD dSize);

PVOID WINAPI IsapiMemoryResize (PVOID pData,
                                DWORD dSize);

PVOID WINAPI IsapiMemoryDestroy (PVOID pData);

PVOID WINAPI IsapiMemoryCopy (PVOID pTarget,
                              PVOID pSource,
                              DWORD dBytes);

HANDLE WINAPI IsapiFileNew (PBYTE pbPath);

HANDLE WINAPI IsapiFileClose (HANDLE hf);

BOOL WINAPI IsapiFileSave (PBYTE pbPath,
                           PVOID pData,
                           DWORD dData);

DWORD WINAPI IsapiFilePath (HINSTANCE hInstance,
                            PBYTE     pbFile,
                            PBYTE     pbBuffer,
                            DWORD     dBuffer);

BOOL WINAPI IsapiHeaderSpace (BYTE bData);

BOOL WINAPI IsapiHeaderEol (BYTE bData);

BOOL WINAPI IsapiHeaderStop (PBYTE pbData,
                             DWORD dData,
                             DWORD dOffset);

DWORD WINAPI IsapiHeaderToken (PBYTE pbData,
                               DWORD dData,
                               DWORD dOffset);

DWORD WINAPI IsapiHeaderNext (PBYTE pbData,
                              DWORD dData,
                              DWORD dOffset);

DWORD WINAPI IsapiHeaderSkip (PBYTE pbData,
                              DWORD dData,
                              DWORD dOffset);

BOOL WINAPI IsapiHeaderTest (PBYTE  pbData,
                             DWORD  dData,
                             PDWORD pdOffset,
                             PBYTE  pbTag,
                             BOOL   fCase);

DWORD WINAPI IsapiHeaderHttp (PBYTE  pbData,
                              DWORD  dData,
                              PDWORD pdOffset);

DWORD WINAPI IsapiHeaderFind (PBYTE  pbData,
                              DWORD  dData,
                              PDWORD pdOffset,
                              PBYTE  pbTag);

DWORD WINAPI IsapiHeaderValue (PBYTE        pbData,
                               DWORD        dData,
                               PDWORD       pdOffset,
                               PBYTE        pbTag,
                               PISAPI_VALUE piv,
                               BOOL         fCase);

PISAPI_TEST WINAPI IsapiTestLoad (PBYTE pbPath);

PISAPI_TEST WINAPI IsapiTestUnload (PISAPI_TEST pit);

BOOL WINAPI IsapiTestStart (PISAPI_TEST       pit,
                            PHSE_VERSION_INFO phvi);

BOOL WINAPI IsapiTestStop (PISAPI_TEST pit);

BOOL WINAPI IsapiTestRun (PISAPI_TEST pit,
                          PBYTE       pbPath,
                          PBYTE       pbInfo,
                          PBYTE       pbTranslated,
                          PBYTE       pbQuery,
                          BOOL        fPost);

BOOL WINAPI IsapiTestDisplay (PISAPI_TEST pit);

BOOL WINAPI IsapiTestOut (PEXTENSION_CONTROL_BLOCK pecb,
                          PVOID                    pData,
                          DWORD                    dData);

BOOL WINAPI IsapiTestGetServerVariable (HCONN  hConn,
                                        PSTR   psVariableName,
                                        PVOID  pBuffer,
                                        PDWORD pdSize);

BOOL WINAPI IsapiTestWriteClient (HCONN  hConn,
                                  PVOID  pBuffer,
                                  PDWORD pdSize,
                                  DWORD  dReserved);

BOOL WINAPI IsapiTestReadClient (HCONN  hConn,
                                 PVOID  pBuffer,
                                 PDWORD pdSize);

BOOL WINAPI IsapiTestServerSupportFunction (HCONN  hConn,
                                            DWORD  dRequest,
                                            PVOID  pBuffer,
                                            PDWORD pdSize,
                                            PDWORD pdType);

PISAPI_QUERY WINAPI IsapiTestQuery (PBYTE pbData);

DWORD WINAPI IsapiTest (PISAPI_QUERY piq,
                        PVOID       *ppData,
                        PDWORD       pdStatus);

// =================================================================
// LINKER CONTROL
// =================================================================

#ifdef _ISAPISIM_DLL_
#pragma comment (linker, "/entry:\"DllMain\"")
#else
#pragma comment (linker, "/defaultlib:isapisim.lib")
#endif

////////////////////////////////////////////////////////////////////
#endif // #ifndef _RC_PASS_
////////////////////////////////////////////////////////////////////

// =================================================================
// END OF FILE
// =================================================================
