// sender.c

#include <windows.h>
#include "sender.h"

int CALLBACK SendDlgProc(HWND, UINT, WPARAM, LPARAM);
LRESULT WINAPI MySendMessageTimeout(HWND, UINT, WPARAM, LPARAM, 
                                    DWORD, DWORD *);

TCHAR sz[MAX_PATH];
HANDLE hInst;
HWND hRecvWnd = NULL;

//-----------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
    hInst = hInstance;
    DialogBox(hInst,MAKEINTRESOURCE(DLG_SENDER),NULL,SendDlgProc);
    return 0;
}

//-----------------------------------------------------------------
int CALLBACK SendDlgProc(HWND hDlg, UINT Message, WPARAM wParam,
                         LPARAM lParam)
{
    DWORD status, dwResult = 0;
    static DWORD i = 0;
    static HWND hList = NULL;
    int iTimeout = 0;

    switch (Message) {
        case WM_INITDIALOG:
            hList = GetDlgItem(hDlg, ID_RESULT);
            SendMessage(hList, LB_RESETCONTENT, 0, 0);
            return TRUE;

        case WM_COMMAND:
            switch (LOWORD(wParam)) {
                case ID_SEND:
                    if (!hRecvWnd) {
                        hRecvWnd = FindWindow(TEXT("#32770"), 
                                       TEXT("Message Receiver"));
                    }
                    iTimeout = GetDlgItemInt(hDlg, ID_TIMEOUT, 
                                             NULL, TRUE);

                    status = MySendMessageTimeout(hRecvWnd, 
                                                  WM_APP+100,
                                                  (LPARAM)hDlg,i,
                                                  iTimeout,
                                                  &dwResult);

                    wsprintf(sz, TEXT("hDlg=%x, i=%x, Result=%x"),
                             (DWORD)hDlg, i, dwResult);
                    SendMessage(hList,LB_ADDSTRING,0,(LPARAM)sz);
                    i++;
                    break;

                case IDCANCEL:
                    EndDialog(hDlg, TRUE);
                    return TRUE;
            }

        default:
            return FALSE;
    }
    return FALSE;

} // SenderDlgProc

