#include <windows.h>
#include <windowsx.h>
#include <assert.h>
#include "winutils.h"

void WINAPI adjustToWorkArea( HWND hwndDlg ) {
    RECT rcWorkArea = { 0 };
    RECT rcWindow   = { 0 };
    
    assert( IsWindow( hwndDlg ) );
    SystemParametersInfo( SPI_GETWORKAREA, 0, &rcWorkArea, 0 );
    GetWindowRect( hwndDlg, &rcWindow );
    
    if ( rcWorkArea.right < rcWindow.right ) {
        rcWindow.left -= rcWindow.right - rcWorkArea.right;
    }
    if ( rcWindow.left < rcWorkArea.left ) {
        rcWindow.left = rcWorkArea.left;
    }
    
    if ( rcWorkArea.bottom < rcWindow.bottom ) {
        rcWindow.top -= rcWindow.bottom - rcWorkArea.bottom;
    }
    if ( rcWindow.top < rcWorkArea.top ) {
        rcWindow.top = rcWorkArea.top;
    }
    
    SetWindowPos( hwndDlg, 0, rcWindow.left, rcWindow.top, 0, 0, 
        SWP_NOZORDER | SWP_NOSIZE | SWP_NOACTIVATE );
}

// Note: This won't work on variable-height items.
void WINAPI ListBox_EnsureVisible( HWND hwndList, int nIndex ) {
    RECT rcList = { 0 };
    RECT rcItem = { 0 };
    
    int nItemHeight = 0, nDelta = 0, nItemsToMove = 0;
    const int nTopIndex = ListBox_GetTopIndex( hwndList );
    
    assert( IsWindow( hwndList ) );
    GetClientRect( hwndList, &rcList );
    ListBox_GetItemRect( hwndList, nIndex, &rcItem );
    nItemHeight = rcItem.bottom - rcItem.top;
    
    if ( 0 < nItemHeight ) { // ...'cause div by zero is Bad :-)
        if ( rcList.bottom < rcItem.bottom ) {
            nDelta = rcItem.bottom - rcList.bottom;
            nItemsToMove = (nDelta + nItemHeight - 1) / nItemHeight;
        } else if ( rcItem.top < rcList.top ) {
            nDelta = rcItem.top - rcList.top;
            nItemsToMove = (nDelta - nItemHeight + 1) / nItemHeight;
        }
    }
    
    ListBox_SetTopIndex( hwndList, nTopIndex + nItemsToMove );
}

/* end of file */
